% Chapter 8: Geometric problems
%
%  separate_pt_poly.m           - Section 8.1.1: Separating a point from a polyhedron
%  separate_poly_2D.m           - Section 8.2.2: Separating polyhedra in 2D
%  analytic_center.m            - Section 8.5.3: Analytic center of a set of linear inequalities
%  svm_1.m                      - Figure 8.10: Approximate linear discrimination via linear programming
%  svm_2.m                      - Figure 8.11: Approximate linear discrimination via support vector classifier
%  placement_lin.m              - Figure 8.15: Linear placement problem
%  placement_quad.m             - Figure 8.16: Quadratic placement problem
%  placement_quar.m             - Figure 8.17: Fourth-order placement problem
%  linear_discr.m               - Figure 8.8: Simplest linear discrimination
%  robust_lin_discr.m           - Figure 8.9: Robust linear discrimination problem
%  ex_8_3.m                     - Example 8.3: Bounding correlation coefficients
%  ex_8_4.m                     - Example 8.4: One free point localization
%  test_floorplan.m             - Example 8.7: Floorplan generation test script
%  eucl_dist_poly.m             - Euclidean distance between polyhedra
%  eucl_dist_poly_2D.m          - Euclidean distance between polyhedra in 2D
%  eucl_proj_hlf.m              - Euclidean projection on a halfspace
%  eucl_proj_hyp.m              - Euclidean projection on a hyperplane
%  eucl_proj_rect.m             - Euclidean projection on a rectangle
%  eucl_proj_cone1.m            - Euclidean projection on the nonnegative orthant
%  eucl_proj_cone2.m            - Euclidean projection on the semidefinite cone
%  floor_plan.m                 - Floor planning
%  max_vol_ellip_in_polyhedra.m - Maximum volume inscribed ellipsoid in a polyhedron
%  min_vol_elp_finite_set.m     - Minimum volume ellipsoid covering a finite set
%  min_vol_union_ellip.m        - Minimum volume ellipsoid covering union of ellipsoids
%  ex_8_5.m                     - One free point localization
%  poly3_discr.m                - Polynomial discrimination
%  poly4_discr.m                - Polynomial discrimination
%  quad_discr.m                 - Quadratic discrimination (separating ellipsoid)
%  separate_ell_2D.m            - Separating ellipsoids in 2D
%  floor_plan_graphs.m          - Solve a floor planning problem given graphs H & V
%  floorplan.m                  - Computes a minimum-perimeter bounding box subject to positioning constraints
%  data_floorplan_32.mat        - (no title)
%  data_floorplan_60.mat        - (no title)
help Contents
