% Graph Laplacian eigenvalue optimization
% <a href="http://stanford.edu/~boyd/cvx_opt_graph_lapl_eigs.html">Convex Optimization of Graph Laplacian Eigenvalues</a>
%
%  larger_example.m   - FDLA and FMMC solutions for a 50-node, 200-edge graph
%  cut_grid_example.m - FDLA and FMMC solutions for a 64-node, 95-edge cut-grid graph
%  small_example.m    - FDLA and FMMC solutions for an 8-node, 13-edge graph
%  fmmc.m             - Computes fastest mixing Markov chain (FMMC) edge weights
%  mh.m               - Computes the Metropolis-Hastings heuristic edge weights
%  best_const.m       - Computes the constant edge weight that yields fastest averaging.
%  fdla.m             - Computes the fastest distributed linear averaging (FDLA) edge weights
%  max_deg.m          - Computes the maximum-degree heuristic edge weights
%  cut_grid_data.m    - Generate a cut-grid graph for the ICM 2006 talk example
%  plotgraph.m        - Plots a graph with each edge width proportional to its weight.
help Contents
